package pl.kaczanowscy.tomek.osgi;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import pl.kaczanowscy.tomek.bundlea.IBundleA;
import pl.kaczanowscy.tomek.bundleb.IBundleB;

/**
 * Runs methods of bundleA and bundleB.
 * 
 * @author Tomek Kaczanowski
 * 
 * 
 */
public class Activator implements BundleActivator {
	public void start(BundleContext bundleContext) throws Exception {
		// bundleA
		ServiceReference refA = bundleContext
				.getServiceReference("pl.kaczanowscy.tomek.bundlea.IBundleA");
		IBundleA bundleA = (IBundleA) bundleContext.getService(refA);
		bundleA.methodA();

		ServiceReference refB = bundleContext
				.getServiceReference("pl.kaczanowscy.tomek.bundleb.IBundleB");
		IBundleB bundleB = (IBundleB) bundleContext.getService(refB);
		bundleB.methodB();
	}

	public void stop(BundleContext arg0) throws Exception {
		try {
			String className = "net.sourceforge.cobertura.coveragedata.ProjectData";
			String methodName = "saveGlobalProjectData";
			Class saveClass = Class.forName(className);
			java.lang.reflect.Method saveMethod = saveClass.getDeclaredMethod(
					methodName, new Class[0]);
			saveMethod.invoke(null, new Object[0]);
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}
}
